
#ifndef _MSYS_DYN_H
#define _MSYS_DYN_H

//
// additional defines and includes
//
// #define _MSYS_DYNDEF_ /* functions redefine, include _msys.h after all includes */
// #define _MSYS_DYNSKIP_ENO_ /* skip errno redefine */
//
// #define _MSYS_MKDIR_F /* mingw compat, skip mingw mkdir define */
//
// #include <_msys/sys/socket.h> /* fd_set defines, errno defines, winsock skip */
// #include <_msys/sys/select.h>
// #define _ERRNO_ONLY
// #include <_msys/sys/errno.h>
// #define _WINSOCK2_H
// #define _WINSOCK_H
//

#define DEF_STDFUNC(f_name, f_type, f_signature) \
	typedef f_type (__stdcall *f_name) f_signature

#define DEF_CFUNC(f_name, f_type, f_signature) \
	typedef f_type (__cdecl *f_name) f_signature

// extern must be used to avoid inline function standalone compilation
#define DEF_INLCALL(f_name, f_type, f_signature, f_namecall, f_params) \
	__attribute__((always_inline)) extern inline f_type f_name f_signature { return f_namecall f_params; }

#ifdef __cplusplus
extern "C" {
#endif

unsigned int _msys_init (void);

// errno.h
int * _msys_errno (void);

// socket.h un.h

int _msys_socket (int, int, int);
int _msys_bind (int, const struct sockaddr *, int);
int _msys_listen (int, int);
int _msys_accept (int, struct sockaddr *, int *);
int _msys_send (int, const void *, int, unsigned int);
int _msys_connect (int, const struct sockaddr *, int);
int _msys_recv (int, void *, int , unsigned int);
int _msys_shutdown (int, int);

int _msys_select (int, fd_set *, fd_set *, fd_set *, struct timeval *);

// unistd.h

FILE * _msys_fdopen (int, const char *);
int _msys_fgetc (FILE *);
int _msys_fputs (const char *, FILE *);
int _msys_fcntl (int, int, ...);

int _msys_close (int);

#ifdef __cplusplus
}
#endif

#ifdef _MSYS_DYNDEF_

#define __GNUC_STDC_INLINE__

#ifndef _MSYS_DYNSKIP_ENO_
#undef errno
#define errno (*_msys_errno())
#endif

DEF_INLCALL(socket, int, (int family, int type, int protocol), _msys_socket, (family, type, protocol))
DEF_INLCALL(bind, int, (int sockfd, const struct sockaddr *addr, int addrlen), _msys_bind, (sockfd, addr, addrlen))
DEF_INLCALL(listen, int, (int sockfd, int n), _msys_listen, (sockfd, n))
DEF_INLCALL(accept, int, (int sockfd, struct sockaddr *peer, int *addrlen), _msys_accept, (sockfd, peer, addrlen))
DEF_INLCALL(send, int, (int sockfd, const void *buff, int len, unsigned int flags), _msys_send, (sockfd, buff, len, flags))
DEF_INLCALL(connect, int, (int sockfd, const struct sockaddr *addr, int addrlen), _msys_connect, (sockfd, addr, addrlen))
DEF_INLCALL(recv, int, (int sockfd, void *buff, int len, unsigned int flags), _msys_recv, (sockfd, buff, len, flags))
DEF_INLCALL(shutdown, int, (int sockfd, int how), _msys_shutdown, (sockfd, how))

DEF_INLCALL(select, int, (int n, fd_set *readfds, fd_set *writefds, fd_set *exceptfds, struct timeval *timeout),
				_msys_select, (n, readfds, writefds, exceptfds, timeout))

DEF_INLCALL(fdopen, FILE *, (int fildes, const char *mode), _msys_fdopen, (fildes, mode))
DEF_INLCALL(fgetc, int, (FILE *stream), _msys_fgetc, (stream))
DEF_INLCALL(fputs, int, (const char *s, FILE *stream), _msys_fputs, (s, stream))
// ##__VA_ARGS__ gcc hack
#define fcntl(p1,p2...) _msys_fcntl(p1,##p2)

DEF_INLCALL(close, int, (int fildes), _msys_close, (fildes))

#endif /* !_MSYS_DYNDEF_ */

#endif /* !_MSYS_DYN_H */
